#include<stdio.h>
#include<algorithm>
#include<math.h>
#include<string.h>
#include<vector>
#include<map>
#include<set>
using namespace std;

#define pb push_back
#define fi first
#define se second
typedef long long ll;
typedef double db;
const int N=1e3+86,MOD=998244353;

int T,id;
int n,m,c,f,a[N][N],b[N][N],ed[N][N];
char s[N];
ll ansc,ansf;

template<typename T>
inline void read(T &x)
{
	T k=1;x=0;char ch=getchar();
	while(ch<'0'||ch>'9'){if(ch=='-')k=-1;ch=getchar();}
	while(ch>='0'&&ch<='9') x=(x<<1)+(x<<3)+(ch^48),ch=getchar();
	x*=k;
}

void solvec()
{
	ll sum=0,p2=0,bes=0;
	for(int j=1;j<=m;j++)
	{
		for(int i=1;i<=n;i++)
		{
			if(a[i][j]==0)
			{
				int tmp=b[i][j]-1,pre=b[i-1][j]-1;
				sum=sum+tmp;
				p2=p2+tmp*tmp;
				if(i>1&&a[i-1][j]==0) bes=bes+tmp*pre;
			}
			else
			{
				ansc=(ansc+(sum*sum-p2)/2-bes);
				sum=p2=bes=0;
			}
		}
		ansc=(ansc+(sum*sum-p2)/2-bes);
		sum=p2=bes=0;
	}
}
void solvef()
{
	int now;
	for(int j=1;j<=m;j++)
	{
		now=0;
		for(int i=n;i>=1;i--)
			if(a[i][j]==0)
			{
				if(now==0) now=ed[i][j]=i;
				else ed[i][j]=now;
			}
			else
			{
				now=ed[i][j]=0;
			}
	}
//	for(int i=1;i<=n;i++)
//	{
//		for(int j=1;j<=m;j++)
//			printf("%d ",ed[i][j]);
//		puts("");
//	}
	ll preb=0;
	for(int j=1;j<=m;j++)
	{
		for(int i=1;i<=n;i++)
			if(a[i][j]==0)
			{
				int tmp=b[i][j]-1,pre=b[i-1][j]-1;
				if(i>1&&a[i-1][j]==0) ansf=ansf+(preb-pre)*tmp*(ed[i][j]-i);
				preb=preb+tmp;
			}
			else preb=0;
	}
}

int main()
{
	freopen("plant.in","r",stdin);
	freopen("plant.out","w",stdout);
//	freopen("plant3.in","r",stdin);
	read(T),read(id);
	while(T--)
	{
		read(n),read(m),read(c),read(f);
		ansc=ansf=0;
		for(int i=1;i<=n;i++)
		{
			scanf("%s",s+1);
			for(int j=1;j<=m;j++)
				a[i][j]=s[j]-'0',b[i][j]=(a[i][j]==1?0:1);
		}
		for(int i=1;i<=n;i++)
			for(int j=m;j>=1;j--)
				if(b[i][j]&&j<m) b[i][j]+=b[i][j+1];
//		for(int i=1;i<=n;i++)
//		{
//			for(int j=1;j<=m;j++)
//				printf("%d ",b[i][j]);
//			puts("");
//		}
		solvec();
		solvef();
		printf("%d %d\n",ansc*c%MOD,ansf*f%MOD);
	}
	return 0;
}
